#define _WIN32_WINNT 0x501
#define _WIN32_IE 0x600

#include <windows.h>
#include <commctrl.h>

LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine,
    int nCmdShow) {

    HWND hWnd;
    MSG messages;
    WNDCLASSEX wincl;

    wincl.hInstance = hInstance;
    wincl.lpszClassName = "WndClass";
    wincl.lpfnWndProc = MainWndProc;
    wincl.style = CS_DBLCLKS;
    wincl.cbSize = sizeof(WNDCLASSEX);

    wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;
    wincl.cbWndExtra = 0;

    wincl.hbrBackground = CreateSolidBrush(GetSysColor(COLOR_BTNFACE));

    if (!RegisterClassEx(&wincl))
        return 0;

    hWnd = CreateWindow("WndClass", "ListView Example",
           WS_OVERLAPPEDWINDOW,
           CW_USEDEFAULT, CW_USEDEFAULT,
           400, 200,
           HWND_DESKTOP, NULL, hInstance, NULL);

    ShowWindow(hWnd, nCmdShow);

    //==========================================================================

    /* Upewnienie si, e biblioteka kontrolek zostaa poprawnie zaadowana */
    INITCOMMONCONTROLSEX icex;

    icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
    icex.dwICC  = ICC_LISTVIEW_CLASSES;
    InitCommonControlsEx(&icex);

    /* Utworzenie kontrolki ListView */
    HWND hListView = CreateWindowEx(WS_EX_CLIENTEDGE, WC_LISTVIEW, NULL,
        WS_VISIBLE | WS_CHILD | LVS_REPORT | LVS_SHAREIMAGELISTS,
        5, 5, 300, 100,
        hWnd, NULL, hInstance, NULL);

    /* Utworzenie obiektu ImageList */
    HIMAGELIST hImageList = ImageList_Create(16, 16, ILC_COLOR4 | ILC_MASK,
        2, 0);

    /* Wczytanie ikon do obiektu ImageList */
    char* icons[] = { "square.ico", "circle.ico", "triangle.ico" };

    for(int i = 0; i < 3; i++) {
        ImageList_AddIcon(hImageList, (HICON) LoadImage(hInstance, icons[i],
            IMAGE_ICON, 16, 16, LR_LOADFROMFILE));
    }

    // Przypisanie obiektu ImageList do kontrolki ListView
    ListView_SetImageList(hListView, hImageList, LVSIL_SMALL);

    /* Utworzenie kolumn kontrolki ListView */
    LVCOLUMN lvColumn = {0};

    lvColumn.mask = LVCF_FMT | LVCF_TEXT | LVCF_WIDTH | LVCF_IMAGE;
    lvColumn.fmt = LVCFMT_LEFT | LVCFMT_IMAGE;
    lvColumn.cx = 90;

    char* columnNames[] = { "First", "Second", "Third" };

    for(int i = 0; i < 3; i++) {
        lvColumn.pszText = columnNames[i];
        lvColumn.iImage = i;

        ListView_InsertColumn(hListView, i, &lvColumn);
    }

    //==========================================================================

    while (GetMessage(&messages, NULL, 0, 0))
    {
        TranslateMessage(&messages);
        DispatchMessage(&messages);
    }

    return messages.wParam;
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
    switch (uMsg)
    {
        case WM_DESTROY:
            PostQuitMessage (0);
            break;

        default:
            return DefWindowProc (hWnd, uMsg, wParam, lParam);
    }

    return 0;
}
